﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Web.UI.HtmlControls;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //this.WebDataGrid1.DataSource = MakeTable();

        if (!Page.IsPostBack)
        {
            //Add behavior
            this.WebDataGrid1.Behaviors.CreateBehavior<Paging>();

            //Handle PageIndexChanged event
            this.WebDataGrid1.Behaviors.Paging.PagingClientEvents.PageIndexChanged = "WebDataGrid1_PageIndexChanged";

            BoundDataField Datacolumn1 = new BoundDataField();
            Datacolumn1.DataFieldName = "id";
            Datacolumn1.Key = "id";
            Datacolumn1.Header.Text = "id";
            Datacolumn1.Hidden = true;
            WebDataGrid1.Columns.Add(Datacolumn1);
            
            Datacolumn1 = new BoundDataField();
            Datacolumn1.DataFieldName = "Item";
            Datacolumn1.Key = "Item";
            Datacolumn1.Header.Text = "Item";
            Datacolumn1.Hidden = false;
            WebDataGrid1.Columns.Add(Datacolumn1);

            Datacolumn1 = new BoundDataField();
            Datacolumn1.DataFieldName = "Data";
            Datacolumn1.Key = "Data";
            Datacolumn1.Header.Text = "Data";
            Datacolumn1.Hidden = false;
            WebDataGrid1.Columns.Add(Datacolumn1);
        }
       
        WebDataGrid1.DataSource = this.MakeTable();
        WebDataGrid1.DataBind();
        
        this.WebDataGrid1.Behaviors.Paging.PagerTemplate = new CustomPagerTemplate();
    }


    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;



        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;

    }


    private class CustomPagerTemplate : ITemplate
    {
        #region ITemplate Members

        public void InstantiateIn(Control container)
        {
            HtmlButton prevButton = new HtmlButton();
            prevButton.ID = "PrevButton";
            prevButton.InnerText = "Prev";
            prevButton.Attributes["onclick"] = "return PreviousPage()";

            DropDownList ddl = new DropDownList();
            ddl.ID = "DropDownList1";

            for (int i = 1; i <= 12; i++)
            {
                ddl.Items.Add(i.ToString());
            }

            ddl.Attributes["onchange"] = "return IndexChanged()";

            HtmlButton nextButton = new HtmlButton();
            nextButton.InnerText = "Next";
            nextButton.Attributes["onclick"] = "return NextPage()";

            container.Controls.Add(prevButton);
            container.Controls.Add(ddl);
            container.Controls.Add(nextButton);
        }

        #endregion
    }
}